=== modified file '.travis.yml'
--- .travis.yml	2021-11-15 14:40:11 +0000
+++ .travis.yml	2022-08-08 16:33:50 +0000
@@ -10,9 +10,7 @@
 matrix:
   include:
     - python: 3.5
-      env: TAL_VERSION=5.2
     - python: 3.6
-      env: TAL_VERSION=5.2
 
 script:
   - python -m coverage run -p -m unittest loggerhead.tests.test_suite
@@ -20,7 +18,7 @@
 install:
   - sudo apt install subunit adduser libjs-jquery
   - travis_retry pip install -U setuptools
-  - travis_retry pip install -U pip coverage codecov flake8 testtools configobj cython testscenarios six docutils python-subunit dulwich bzr+lp:brz pygments paste http://www.owlfish.com/software/simpleTAL/downloads/SimpleTAL-$TAL_VERSION.tar.gz bleach
+  - travis_retry pip install -U pip coverage codecov flake8 testtools configobj cython testscenarios six docutils python-subunit dulwich bzr+lp:brz pygments paste Chameleon bleach
 
 after_success:
   - codecov

=== modified file 'Dockerfile'
--- Dockerfile	2021-07-17 11:02:52 +0000
+++ Dockerfile	2022-08-08 16:33:50 +0000
@@ -4,7 +4,7 @@
 # To use, mount something on /code
 # Logs will be accessible at /logs
 
-RUN apt update && apt install --no-install-recommends -y python3 python3-bleach python3-paste python3-pip python3-patiencediff python3-simpletal python3-dev build-essential python3-pastedeploy python3-dulwich python3-certifi python3-configobj && pip3 install breezy && apt clean && mkdir -p /logs
+RUN apt update && apt install --no-install-recommends -y python3 python3-bleach python3-paste python3-pip python3-patiencediff python3-chameleon python3-dev build-essential python3-pastedeploy python3-dulwich python3-certifi python3-configobj && pip3 install breezy && apt clean && mkdir -p /logs
 ADD . /opt/loggerhead
 ENV PYTHONPATH=/opt/loggerhead
 EXPOSE 8080/tcp

=== modified file 'NEWS'
--- NEWS	2022-08-08 12:52:14 +0000
+++ NEWS	2022-08-08 16:33:50 +0000
@@ -16,6 +16,8 @@
 
     - Avoid use of file ids - use paths instead. (Jelmer Vernooĳ)
 
+    - Port from SimpleTAL to Chameleon. (Colin Watson)
+
 1.20.0 [18Jul2021]
 ------------------
 

=== modified file 'byov.conf'
--- byov.conf	2020-07-08 17:14:19 +0000
+++ byov.conf	2022-08-08 16:33:50 +0000
@@ -6,12 +6,11 @@
 dulwich.clone = (git clone git://jelmer.uk/dulwich ../dulwich.git)
 dulwich.install = (cd ../dulwich.git && ./setup.py install --user)
 dulwich3.install = (cd ../dulwich.git && python3 ./setup.py install --user)
-simpletal3.install = pip3 install http://www.owlfish.com/software/simpleTAL/downloads/SimpleTAL-5.2.tar.gz
 
 [loggerhead]
 vm.release = xenial
 brz.build_deps = gcc, debhelper, python, python-all-dev, python3-all-dev, python-configobj, python3-configobj, python-docutils, python3-docutils, python-paramiko, python3-paramiko, python-subunit, python3-subunit, python-testtools, python3-testtools, subunit, cython, cython3, python-fastimport, python-dulwich, python-six, python3-six
-loggerhead.build_deps = python-setuptools, python3-setuptools, libjs-jquery, python-docutils, python3-docutils, python-pygments, python3-pygments, python-paste, python3-paste, python-pastedeploy, python3-pastedeploy, python-simpletal, python-bleach, python3-bleach
+loggerhead.build_deps = python-setuptools, python3-setuptools, libjs-jquery, python-docutils, python3-docutils, python-pygments, python3-pygments, python-paste, python3-paste, python-pastedeploy, python3-pastedeploy, python-chameleon, python3-chameleon, python-bleach, python3-bleach
 loggerhead.test_deps = python3-fixtures, python-fixtures
 vm.packages = {brz.build_deps}, {loggerhead.build_deps}, {loggerhead.test_deps}, bzr, python-junitxml, python3-pip
 brz.branch = (bzr branch lp:brz ../brz-trunk)
@@ -19,5 +18,5 @@
 byoci.setup.command = ({dulwich.clone} && {dulwich.install} && {brz.branch} && {brz.make})
 byoci.tests.command = bash -o pipefail -c "bzr log -l2 && (BRZ_PLUGINS_AT=loggerhead@`pwd` BRZ_PLUGIN_PATH=-site:-user python2 ../brz-trunk/brz selftest -v --parallel=fork --subunit2 | subunit2junitxml -o ../results.xml -f | subunit2pyunit)"
 [loggerhead-py3]
-byoci.setup.command = ({dulwich.clone} && {dulwich3.install} && {brz.branch} && {brz.make} && {simpletal3.install})
+byoci.setup.command = ({dulwich.clone} && {dulwich3.install} && {brz.branch} && {brz.make})
 byoci.tests.command = bash -o pipefail -c "bzr log -l2 && (BRZ_PLUGINS_AT=loggerhead@`pwd` BRZ_PLUGIN_PATH=-site:-user python3 ../brz-trunk/brz selftest -v --parallel=fork --subunit2 | subunit2junitxml -o ../results.xml -f | subunit2pyunit)"

=== modified file 'docs/index.rst'
--- docs/index.rst	2020-07-08 17:14:19 +0000
+++ docs/index.rst	2022-08-08 16:33:50 +0000
@@ -13,7 +13,7 @@
 
 Loggerhead depends on the following Python libraries.:
 
-- SimpleTAL for templating.
+- Chameleon for templating.
 
 - Paste for the server. (You need version 1.2 or newer of Paste).
 
@@ -27,7 +27,7 @@
 
 .. code-block:: sh
 
-   $ sudo apt-get install python-simpletal
+   $ sudo apt-get install python-chameleon
    $ sudo apt-get install python-paste
    $ sudo apt-get install python-pastedeploy
    $ sudo apt-get install python-flup
@@ -37,9 +37,7 @@
 
 .. code-block:: sh
 
-   $ easy_install \
-     -f http://www.owlfish.com/software/simpleTAL/py2compatible/download.html \
-     SimpleTAL
+   $ easy_install Chameleon
    $ easy_install Paste
    $ easy_install PasteDeploy
    $ easy_install flup

=== modified file 'loggerhead/controllers/view_ui.py'
--- loggerhead/controllers/view_ui.py	2022-07-06 12:45:28 +0000
+++ loggerhead/controllers/view_ui.py	2022-08-08 16:33:50 +0000
@@ -82,7 +82,7 @@
             extra_lines = len(file_lines) - len(hl_lines)
             hl_lines.extend([u''] * extra_lines)
         else:
-            hl_lines = map(util.html_escape, file_lines)
+            hl_lines = [util.html_escape(line) for line in file_lines]
 
         return hl_lines
 

=== modified file 'loggerhead/main.py'
--- loggerhead/main.py	2021-11-15 14:40:11 +0000
+++ loggerhead/main.py	2022-08-08 16:33:50 +0000
@@ -84,14 +84,6 @@
     # if it is configured to suppress it
     handler.setLevel(logging.DEBUG)
     logger.addHandler(handler)
-    def _restrict_logging(logger_name):
-        logger = logging.getLogger(logger_name)
-        if logger.getEffectiveLevel() < logging.INFO:
-            logger.setLevel(logging.INFO)
-    # simpleTAL is *very* verbose in DEBUG mode, which is otherwise the
-    # default. So quiet it up a bit.
-    _restrict_logging('simpleTAL')
-    _restrict_logging('simpleTALES')
     return logger
 
 

=== modified file 'loggerhead/templatefunctions.py'
--- loggerhead/templatefunctions.py	2020-07-08 17:14:19 +0000
+++ loggerhead/templatefunctions.py	2022-08-08 16:33:50 +0000
@@ -180,8 +180,8 @@
         else:
             versions.append(('PasteDeploy', PasteDeploy.version))
 
-        import simpletal
-        versions.append(('SimpleTAL', simpletal.__version__))
+        Chameleon = pkg_resources.get_distribution('Chameleon')
+        versions.append(('Chameleon', Chameleon.version))
 
         try:
             import pygments

=== modified file 'loggerhead/templates/atom.pt'
--- loggerhead/templates/atom.pt	2010-05-05 18:42:58 +0000
+++ loggerhead/templates/atom.pt	2022-08-08 16:33:50 +0000
@@ -1,7 +1,7 @@
 <?xml version="1.0" encoding="utf-8"?>
 <feed xmlns="http://www.w3.org/2005/Atom" xmlns:tal="http://xml.zope.org/namespaces/tal">
   <title>
-    bazaar changes for <tal:branch-name content="branch/friendly_name">branch name</tal:branch-name>
+    bazaar changes for <tal:branch-name content="branch.friendly_name">branch name</tal:branch-name>
   </title>
   <updated tal:content="string:${updated}Z">${updated}</updated>
   <id tal:content="python:branch.absolute_url(['/atom'])">url</id>
@@ -9,22 +9,22 @@
   <link rel="alternate" type="text/html" tal:attributes="href python:branch.url(['/changes'])" />
 
   <entry tal:repeat="entry changes">
-    <title tal:content="string:${entry/revno}: ${entry/short_comment}">
-      ${entry/revno}: ${entry/short_comment}
+    <title tal:content="string:${entry.revno}: ${entry.short_comment}">
+      ${entry.revno}: ${entry.short_comment}
     </title>
-    <updated tal:content="string:${entry/utc_date/isoformat}Z">
+    <updated tal:content="string:${entry.utc_date.isoformat}Z">
       updated
     </updated>
     <!-- TODO: The feed validator will generate warnings because this is URL-encoded -->
     <id tal:content="python:branch.absolute_url(['/revision', entry.revno])">
       ID
     </id>
-    <author tal:repeat="author entry/authors">
+    <author tal:repeat="author entry.authors">
       <name tal:content="python:util.hide_email(author)">
         author
       </name>
     </author>
-    <content type="text" tal:content="entry/comment">
+    <content type="text" tal:content="entry.comment">
       comment
     </content>
     <link rel="alternate" type="text/html"

=== modified file 'loggerhead/templates/breadcrumbs.pt'
--- loggerhead/templates/breadcrumbs.pt	2012-01-08 21:43:42 +0000
+++ loggerhead/templates/breadcrumbs.pt	2022-08-08 16:33:50 +0000
@@ -10,12 +10,12 @@
 
 <!-- Branch breadcrumbs (for the path within the branch) -->
 <span metal:define-macro="branch" class="breadcrumb">
-    <tal:block repeat="crumb branch_breadcrumbs">/<a tal:attributes="href python:url([crumb['suffix'], change.revno, crumb['path']])" tal:content="crumb/dir_name" tal:condition="not:repeat/crumb/end" /><span tal:replace="crumb/dir_name" tal:condition="repeat/crumb/end" /></tal:block>
+    <tal:block repeat="crumb branch_breadcrumbs">/<a tal:attributes="href python:url([crumb['suffix'], change.revno, crumb['path']])" tal:content="crumb.dir_name" tal:condition="not:repeat.crumb.end" /><span tal:replace="crumb.dir_name" tal:condition="repeat.crumb.end" /></tal:block>
 </span>
 
 <!-- Directory breadcrumbs (for the path leading up to the branch) -->
 <span metal:define-macro="directory" class="breadcrumb">
-    <tal:block repeat="crumb directory_breadcrumbs"><span tal:condition="not:repeat/crumb/start">/</span><a tal:attributes="href python:static_url('/'+crumb['path'])" tal:content="crumb/dir_name" /></tal:block>
+    <tal:block repeat="crumb directory_breadcrumbs"><span tal:condition="not:repeat.crumb.start">/</span><a tal:attributes="href python:static_url('/'+crumb['path'])" tal:content="crumb.dir_name" /></tal:block>
 </span>
 
 </body>

=== modified file 'loggerhead/templates/changelog.pt'
--- loggerhead/templates/changelog.pt	2022-07-06 12:45:28 +0000
+++ loggerhead/templates/changelog.pt	2022-08-08 16:33:50 +0000
@@ -1,12 +1,12 @@
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros/main">
+<html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros.main">
   <head>
     <title metal:fill-slot="title"
-           tal:content="string:${branch/friendly_name} : changes"></title>
+           tal:content="string:${branch.friendly_name} : changes"></title>
     <metal:block fill-slot="header_extras">
       <link rel="alternate" type="application/atom+xml"
             tal:attributes="href python:url(['/atom']);
-                            title string:RSS feed for ${branch/friendly_name}" />
+                            title string:RSS feed for ${branch.friendly_name}" />
     <script type="text/javascript">
       var revids = <tal:block content="data" />;
     </script>
@@ -17,25 +17,25 @@
 
   <body>
       <tal:block metal:fill-slot="backlink">
-          <tal:has-link condition="branch/branch_link">
+          <tal:has-link condition="branch.branch_link">
             <div class="black-link">
-                <a tal:attributes="href branch/branch_link">
+                <a tal:attributes="href branch.branch_link">
                   &#8592; Back to branch summary
                 </a>
             </div>
           </tal:has-link>
       </tal:block>
-    <tal:block metal:fill-slot="branchname" tal:content="string:${branch/friendly_name}" />
+    <tal:block metal:fill-slot="branchname" tal:content="branch.friendly_name" />
     <tal:block metal:fill-slot="heading">
         <div id="breadcrumbs">
-            <tal:has-link condition="branch/branch_link">
-              <a tal:attributes="href branch/branch_link"
-                 tal:content="branch/friendly_name">
+            <tal:has-link condition="branch.branch_link">
+              <a tal:attributes="href branch.branch_link"
+                 tal:content="branch.friendly_name">
                 nice/branch/name
               </a>
             </tal:has-link>
-            <tal:no-link condition="not: branch/branch_link">
-              <span metal:use-macro="breadcrumbs/directory"></span>
+            <tal:no-link condition="not: branch.branch_link">
+              <span metal:use-macro="breadcrumbs.directory"></span>
             </tal:no-link>
             <tal:block condition="changes">
               &#187; Changes
@@ -60,11 +60,11 @@
         No revisions!
       </p>
 
-      <p class="fr revnolink">From Revision <a tal:attributes="href #
+      <p class="fr revnolink">From Revision <a tal:attributes="href string:#
                                                                title python:'Show revision '+history.get_revno(revid)"
                                                tal:content="python:history.get_revno(revid)"></a>
         <tal:block tal:condition="python:navigation.last_in_page_revid is not None"> to
-          <a tal:attributes="href #
+          <a tal:attributes="href string:#
                              title 'Show revision '+history.get_revno(navigation.last_in_page_revid)"
              tal:content="python:history.get_revno(navigation.last_in_page_revid)"></a>
       </tal:block></p>
@@ -89,8 +89,8 @@
           <th class="downloadcell">Files</th>
         </tr>
         <tal:block tal:repeat="entry changes">
-          <a tal:attributes="name string:entry-${entry/revno}"/>
-          <tr tal:attributes="class string:blueRow${entry/parity} revision_log; id string:log-${entry/index}">
+          <a tal:attributes="name string:entry-${entry.revno}"/>
+          <tr tal:attributes="class string:blueRow${entry.parity} revision_log; id string:log-${entry.index}">
             <td class="revnro revnolink"><a tal:attributes="title python:'Show revision '+entry.revno;
                                                             href  python:url(['/revision', entry.revno], clear=1)"
                                             tal:content="python:util.trunc(entry.revno)"></a>
@@ -110,7 +110,7 @@
                 <a tal:attributes="title python:'Show revision '+entry.revno;
                                    href  python:url(['/revision', entry.revno], clear=1);
                                    class string:link"
-                   tal:content="entry/short_comment"></a>
+                   tal:content="entry.short_comment"></a>
               </div>
               <div class="long_description" style="display: none">
                 <img tal:condition="python:entry.parents[1:]"
@@ -126,7 +126,7 @@
             </td>
             <td tal:content="python:util.trunc(util.hide_email(entry.authors[0]), 20)"
                 class="autcell"></td>
-            <td tal:condition="show_tag_col" tal:content="string:${entry/tags}"
+            <td tal:condition="show_tag_col" tal:content="string:${entry.tags}"
                 class="tagcell"></td>
             <td class="date">
               <span tal:attributes="title python:util.date_time(entry.utc_date)"
@@ -136,7 +136,7 @@
                                                  href python:url(['/revision', entry.revno], clear=1)">
                 <img tal:attributes="src python:branch.static_url('/static/images/ico_diff.gif')" alt="Diff" /></a></td>
             <td class="downr"><a tal:attributes="href python:branch.url(['/files', entry.revno]);
-                                                 title string:Files at revision ${entry/revno}">
+                                                 title string:Files at revision ${entry.revno}">
                 <img tal:attributes="src python:branch.static_url('/static/images/ico_file.gif')" alt="Files" /></a>
             </td>
           </tr>
@@ -145,9 +145,9 @@
 
       <ul tal:condition="python:navigation.prev_page_revid or navigation.next_page_revid"
           id="pages">
-        <li tal:condition="navigation/prev_page_revid"
+        <li tal:condition="navigation.prev_page_revid"
             class="previous">
-          <a tal:attributes="href navigation/prev_page_url">&laquo; Newer</a>
+          <a tal:attributes="href navigation.prev_page_url">&laquo; Newer</a>
         </li>
         <!-- FIXME: Leaving this to eventually show page numbers. Can't show all of them,
              so some magic has to be done to just show the previous and next N page numbers
@@ -157,9 +157,9 @@
                <li><a href="#"
                       tal:content="page_number"></a></li>
              </tal:block>-->
-        <li tal:condition="navigation/next_page_revid"
+        <li tal:condition="navigation.next_page_revid"
             class="next">
-          <a tal:attributes="href navigation/next_page_url">Older &raquo;</a>
+          <a tal:attributes="href navigation.next_page_url">Older &raquo;</a>
         </li>
       </ul>
 

=== modified file 'loggerhead/templates/directory.pt'
--- loggerhead/templates/directory.pt	2018-09-08 17:34:27 +0000
+++ loggerhead/templates/directory.pt	2022-08-08 16:33:50 +0000
@@ -16,7 +16,7 @@
     <div id="loggerheadCont">
       <h1>
         Browsing
-        <span metal:use-macro="breadcrumbs/directory" />
+        <span metal:use-macro="breadcrumbs.directory" />
       </h1>
 
       <div >
@@ -37,17 +37,17 @@
           </tr>
           <tal:block repeat="dir dirs">
 
-            <tal:branch-row tal:condition="dir/branch">
-              <tr tal:attributes="class string:blueRow${dir/parity}">
+            <tal:branch-row tal:condition="dir.branch">
+              <tr tal:attributes="class string:blueRow${dir.parity}">
                 <td class="date">
-                    <a tal:attributes="href string:${dir/dirname}/files">
+                    <a tal:attributes="href string:${dir.dirname}/files">
                         <img tal:attributes="src python:static_url('/static/images/ico_branch.gif')" alt="Branch" />
                     </a>
-                  <a tal:attributes="href string:${dir/dirname}/files" tal:content="dir/dirname" /></td>
+                  <a tal:attributes="href string:${dir.dirname}/files" tal:content="dir.dirname" /></td>
                 <td class="date">
-                  <a tal:attributes="href string:${dir/dirname}/revision/${dir/branch/revno};
-                                     title string:Show revision ${dir/branch/revno}"
-                     tal:content="dir/branch/revno"></a>
+                  <a tal:attributes="href string:${dir.dirname}/revision/${dir.branch.revno};
+                                     title string:Show revision ${dir.branch.revno}"
+                     tal:content="dir.branch.revno"></a>
                 </td>
                 <td class="date" tal:content="python:util._approximatedate(dir.last_change_time)"></td>
                 <td class="date" tal:content="python:util.hide_email(dir.last_revision.committer) if dir.last_revision is not None else 'Nobody'"></td>
@@ -55,15 +55,15 @@
               </tr>
 
             </tal:branch-row>
-            <tal:non-branch-row tal:condition="not:dir/branch">
-              <tr tal:attributes="class string:blueRow${dir/parity}">
+            <tal:non-branch-row tal:condition="not:dir.branch">
+              <tr tal:attributes="class string:blueRow${dir.parity}">
                 <td class="date">
-                    <a tal:attributes="href string:${dir/dirname}/">
+                    <a tal:attributes="href string:${dir.dirname}/">
                         <img tal:attributes="src python:static_url('/static/images/ico_folder.gif')" alt="Folder" />
                     </a>
-                  <a tal:attributes="href string:${dir/dirname}/" tal:content="dir/dirname" /></td>
+                  <a tal:attributes="href string:${dir.dirname}/" tal:content="dir.dirname" /></td>
                 <td class="date"></td>
-                <td class="date" colspan="4" tal:content="dir/last_change"></td>
+                <td class="date" colspan="4" tal:content="dir.last_change"></td>
               </tr>
             </tal:non-branch-row>
           </tal:block>

=== modified file 'loggerhead/templates/error.pt'
--- loggerhead/templates/error.pt	2008-09-29 21:32:30 +0000
+++ loggerhead/templates/error.pt	2022-08-08 16:33:50 +0000
@@ -1,21 +1,21 @@
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
 <tal:block define="onload string:load()">
-  <html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros/main">
+  <html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros.main">
     <head>
       <title metal:fill-slot="title"
-             tal:content="string:${branch/friendly_name} : error"></title>
+             tal:content="string:${branch.friendly_name} : error"></title>
     </head>
     <body>
         <tal:block metal:fill-slot="heading">
         <h1>
-           <tal:has-link condition="branch/branch_link">
-            <a tal:attributes="href branch/branch_link"
-               tal:content="branch/friendly_name">
+           <tal:has-link condition="branch.branch_link">
+            <a tal:attributes="href branch.branch_link"
+               tal:content="branch.friendly_name">
                nice/branch/name
             </a>
            </tal:has-link>
-            <tal:no-link condition="not: branch/branch_link">
-                <span metal:use-macro="breadcrumbs/directory"></span>
+            <tal:no-link condition="not: branch.branch_link">
+                <span metal:use-macro="breadcrumbs.directory"></span>
             </tal:no-link>
            : error
         </h1>

=== modified file 'loggerhead/templates/feed-link.pt'
--- loggerhead/templates/feed-link.pt	2008-08-13 15:18:17 +0000
+++ loggerhead/templates/feed-link.pt	2022-08-08 16:33:50 +0000
@@ -1,6 +1,6 @@
 <tal:feed-link>
   <a tal:attributes="href python:url(['/atom']);
-                     title string:RSS feed for ${branch/friendly_name}">
+                     title string:RSS feed for ${branch.friendly_name}">
     <img tal:attributes="src python:branch.static_url('/static/images/ico_rss.gif')" alt="RSS" class="rssfeed"/>
   </a>
 </tal:feed-link>

=== modified file 'loggerhead/templates/filediff.pt'
--- loggerhead/templates/filediff.pt	2009-04-01 15:28:21 +0000
+++ loggerhead/templates/filediff.pt	2022-08-08 16:33:50 +0000
@@ -2,7 +2,7 @@
   <div class="pseudotable unified"
        tal:repeat="chunk chunks">
 
-    <tal:block condition="not:repeat/chunk/start">
+    <tal:block condition="not:repeat.chunk.start">
       <div class="pseudorow context-row">
         <div class="lineNumber separate"></div>
         <div class="lineNumber second separate"></div>
@@ -11,13 +11,13 @@
       </div>
     </tal:block>
 
-    <div tal:repeat="line chunk/diff"
-         tal:attributes="class string:pseudorow ${line/type}-row">
+    <div tal:repeat="line chunk.diff"
+         tal:attributes="class string:pseudorow ${line.type}-row">
       <div class="lineNumber first"
            tal:content="structure python:util.fill_div(line.old_lineno)"></div>
       <div class="lineNumber second"
            tal:content="structure python:util.fill_div(line.new_lineno)"></div>
-      <div tal:attributes="class string:code ${line/type}"
+      <div tal:attributes="class string:code ${line.type}"
            tal:content="structure python:util.fill_div(util.html_clean(line.line))"></div>
       <div class="clear"><!-- --></div>
     </div>

=== modified file 'loggerhead/templates/inventory.pt'
--- loggerhead/templates/inventory.pt	2022-07-06 12:45:28 +0000
+++ loggerhead/templates/inventory.pt	2022-08-08 16:33:50 +0000
@@ -1,8 +1,8 @@
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros/main">
+<html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros.main">
   <head>
     <title metal:fill-slot="title"
-           tal:content="string:${branch/friendly_name} : files for revision ${change/revno}"></title>
+           tal:content="string:${branch.friendly_name} : files for revision ${change.revno|nothing}"></title>
     <metal:block fill-slot="header_extras">
         <link rel="stylesheet" type="text/css" media="all"
               tal:attributes="href python:branch.static_url('/static/css/files.css')"/>
@@ -10,27 +10,27 @@
   </head>
   <body>
       <tal:block metal:fill-slot="backlink">
-          <tal:has-link condition="branch/branch_link">
+          <tal:has-link condition="branch.branch_link">
             <div class="black-link">
-                <a tal:attributes="href branch/branch_link">
+                <a tal:attributes="href branch.branch_link">
                   &#8592; Back to branch summary
                 </a>
             </div>
           </tal:has-link>
       </tal:block>
-      <tal:block metal:fill-slot="branchname" tal:content="string:${branch/friendly_name}" />
+      <tal:block metal:fill-slot="branchname" tal:content="branch.friendly_name" />
           <tal:block metal:fill-slot="heading">
           <div id="breadcrumbs">
-          <tal:has-link condition="branch/branch_link">
-            <a tal:attributes="href branch/branch_link"
-               tal:content="branch/friendly_name">
+          <tal:has-link condition="branch.branch_link">
+            <a tal:attributes="href branch.branch_link"
+               tal:content="branch.friendly_name">
               nice/branch/name
             </a>
           </tal:has-link>
-          <tal:no-link condition="not: branch/branch_link">
-            <span metal:use-macro="breadcrumbs/directory"></span>
+          <tal:no-link condition="not: branch.branch_link">
+            <span metal:use-macro="breadcrumbs.directory"></span>
           </tal:no-link>
-          <span>: <span metal:use-macro="breadcrumbs/branch" /> (Revision <tal:revno content="change/revno"></tal:revno>)</span>
+          <span>: <span metal:use-macro="breadcrumbs.branch" /> (Revision <tal:revno content="change.revno|nothing"></tal:revno>)</span>
         </div>
       </tal:block>
 
@@ -77,25 +77,25 @@
 
             <!-- Show this if it's a directory -->
             <tal:block repeat="file filelist">
-            <tr tal:attributes="class string:blueRow${repeat/file/even}" tal:condition="python:file.kind=='directory'">
+            <tr tal:attributes="class string:blueRow${repeat.file.even}" tal:condition="python:file.kind=='directory'">
                 <td class="date"><a tal:attributes="href python:url(['/files', revno_url, file.absolutepath])">
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_folder.gif');
-                                             title string:Go to ${file/filename}" />
+                                             title string:Go to ${file.filename}" />
                     </a>
 
                  <a tal:attributes="href python:url(['/files', revno_url, file.absolutepath])"
-                                        tal:content="file/filename" class="link"></a>
+                                        tal:content="file.filename" class="link"></a>
                  </td>
                  <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
-                                                     title string:Show revision ${file/change/revno}"
-                                     tal:content="file/change/revno"></a>
+                                                     title string:Show revision ${file.change.revno}"
+                                     tal:content="file.change.revno"></a>
                  </td>
                  <td class="date" tal:content="python:util._approximatedate(file.change.utc_date)"></td> 
                  <td class="date" tal:content="python:util.hide_email(file.change.committer)"></td>
                  <td class="autcell" tal:content="python:file.change.comment[:50]"></td>
                  <td class="timedate2"></td><!-- not showing sizes of folders -->
                  <td class="expcell"><a tal:attributes="href python:url(['/changes'], start_revid=start_revid, filter_path=file.absolutepath);
-                                                     title string:Show revision ${file/change/revno}">
+                                                     title string:Show revision ${file.change.revno}">
                                       <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif')" alt="Diff" />
                                      </a>
               </td>
@@ -103,48 +103,48 @@
             </tr>
 
             <!-- Show this if it's a symlink -->
-            <tr tal:attributes="class string:blueRow${repeat/file/even}" tal:condition="python:file.kind=='symlink'">
+            <tr tal:attributes="class string:blueRow${repeat.file.even}" tal:condition="python:file.kind=='symlink'">
                 <td class="date"><a tal:attributes="href python:url(['/view', change.revno, file.absolutepath])">
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_file_flecha.gif')" alt="Symlink" />
                     </a>
 
                  <a tal:attributes="href python:url(['/view', revno_url, file.absolutepath])"
-                                        tal:content="file/filename" class="link"></a>
+                                        tal:content="file.filename" class="link"></a>
                  </td>
                  <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
-                                                     title string:Show revision ${file/change/revno}"
-                                     tal:content="file/change/revno"></a>
+                                                     title string:Show revision ${file.change.revno}"
+                                     tal:content="file.change.revno"></a>
                  </td>
                  <td class="date" tal:content="python:util._approximatedate(file.change.utc_date)"></td> 
                  <td class="date" tal:content="python:util.hide_email(file.change.committer)"></td>
                  <td class="autcell" tal:content="python:file.change.comment[:50]"></td>
                  <td class="timedate2">.</td>
                  <td class="expcell"><a tal:attributes="href python:url(['/changes'], start_revid=start_revid, filter_path=file.absolutepath);
-                                                        title string:Show revision ${file/change/revno}">
+                                                        title string:Show revision ${file.change.revno}">
                                           <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif');
-                                                               title string:Show revision ${file/change/revno}" />
+                                                               title string:Show revision ${file.change.revno}" />
                                      </a>
               </td>
                 <td class="expcell"></td>
             </tr>
 
             <!-- Show this if it's a regular file -->
-            <tr tal:attributes="class string:blueRow${repeat/file/even}" tal:condition="python:file.kind=='file'">
+            <tr tal:attributes="class string:blueRow${repeat.file.even}" tal:condition="python:file.kind=='file'">
                 <td class="date"><a tal:attributes="href python:url(['/view', revno_url, file.absolutepath])">
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_file.gif');
-                                             title string:View ${file/filename}"
+                                             title string:View ${file.filename}"
                              tal:condition="python:file.executable is False" />
                         <!-- Show a different icon id the file executable -->
                         <img tal:attributes="src python:branch.static_url('/static/images/ico_file_modify.gif');
-                                             title string:View ${file/filename}"
+                                             title string:View ${file.filename}"
                              tal:condition="python:file.executable is True" alt="File" />
                     </a>
 
               <a tal:attributes="href python:url(['/view', revno_url, file.absolutepath])"
-                                     tal:content="file/filename" class="link"></a></td>
+                                     tal:content="file.filename" class="link"></a></td>
               <td class="date"><a tal:attributes="href python:url(['/revision', file.change.revno]);
-                                                  title string:Show revision ${file/change/revno}"
-                                  tal:content="file/change/revno"></a>
+                                                  title string:Show revision ${file.change.revno}"
+                                  tal:content="file.change.revno"></a>
               </td>
                  <td class="date" tal:content="python:util._approximatedate(file.change.utc_date)"></td> 
                  <td class="date" tal:content="python:util.hide_email(file.change.committer)"></td>
@@ -152,13 +152,13 @@
 
               <td class="timedate2" tal:content="python:util.human_size(file.size)"></td>
               <td class="expcell"><a tal:attributes="href python:url(['/view', revno_url, file.absolutepath]);
-                                                     title string:View ${file/filename}">
+                                                     title string:View ${file.filename}">
                                       <img tal:attributes="src python:branch.static_url('/static/images/ico_planilla.gif')" alt="Diff" />
                                      </a>
               </td>
               <td class="expcell">
                  <a tal:attributes="href python:url(['/download', file.revid.decode('utf-8'), file.filename]);
-                                    title string:Download ${file/filename} at revision ${file/change/revno}">
+                                    title string:Download ${file.filename} at revision ${file.change.revno}">
                    <img tal:attributes="src python:branch.static_url('/static/images/ico_file_download.gif')" alt="Download File" />
                  </a>
               </td>

=== modified file 'loggerhead/templates/macros.pt'
--- loggerhead/templates/macros.pt	2020-06-04 19:43:36 +0000
+++ loggerhead/templates/macros.pt	2022-08-08 16:33:50 +0000
@@ -35,7 +35,7 @@
       <h1 class="branch-name">
         <span metal:define-slot="branchname" />
       </h1>
-      <tal:menu define="fileview_active fileview_active"
+      <tal:menu define="fileview_active fileview_active|False"
                 replace="structure python:menu(branch, url, fileview_active)" />
       <div id="loggerheadCont">
 

=== modified file 'loggerhead/templates/revision.pt'
--- loggerhead/templates/revision.pt	2015-03-17 15:12:05 +0000
+++ loggerhead/templates/revision.pt	2022-08-08 16:33:50 +0000
@@ -1,9 +1,9 @@
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
 <tal:block define="onload string:load()">
-  <html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros/main">
+  <html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros.main">
     <head>
       <title metal:fill-slot="title"
-             tal:content="string:${branch/friendly_name} : revision ${change/revno}">
+             tal:content="string:${branch.friendly_name} : revision ${change.revno}">
       </title>
 
       <metal:block fill-slot="header_extras">
@@ -21,29 +21,29 @@
 
     <body>
       <tal:block metal:fill-slot="backlink">
-          <tal:has-link condition="branch/branch_link">
+          <tal:has-link condition="branch.branch_link">
             <div class="black-link">
-                <a tal:attributes="href branch/branch_link">
+                <a tal:attributes="href branch.branch_link">
                   &#8592; Back to branch summary
                 </a>
             </div>
           </tal:has-link>
       </tal:block>
-      <tal:block metal:fill-slot="branchname" tal:content="string:${branch/friendly_name}" />
+      <tal:block metal:fill-slot="branchname" tal:content="branch.friendly_name" />
       <tal:block metal:fill-slot="heading">
         <div id="breadcrumbs">
-          <tal:has-link condition="branch/branch_link">
-            <a tal:attributes="href branch/branch_link"
-               tal:content="branch/friendly_name">
+          <tal:has-link condition="branch.branch_link">
+            <a tal:attributes="href branch.branch_link"
+               tal:content="branch.friendly_name">
               nice/branch/name
             </a>
           </tal:has-link>
-          <tal:no-link condition="not: branch/branch_link">
-            <span metal:use-macro="breadcrumbs/directory"></span>
+          <tal:no-link condition="not: branch.branch_link">
+            <span metal:use-macro="breadcrumbs.directory"></span>
           </tal:no-link>
           <span class="breadcrumb">&#187; Revision
-            <tal:revno condition="not:specific_path" content="change/revno"></tal:revno>
-            <a tal:condition="specific_path" tal:content="change/revno"
+            <tal:revno condition="not:specific_path" content="change.revno"></tal:revno>
+            <a tal:condition="specific_path" tal:content="change.revno"
                tal:attributes="href python:url(['/revision', change.revno])"
                title="View changes to all files"></a>
                       <tal:compare-to condition="python:compare_revid is not None">
@@ -56,7 +56,7 @@
         </div>
         <tal:branch-info replace="structure python:branchinfo(branch)" />
         <h1 tal:condition="not:specific_path">
-          Viewing all changes in revision <tal:revno content="change/revno" />.
+          Viewing all changes in revision <tal:revno content="change.revno" />.
         </h1>
         <p tal:condition="specific_path">
           <a tal:attributes="href python:url(['/revision', change.revno])">
@@ -68,8 +68,8 @@
         </p>
         <ul id="submenuTabs">
           <li id="first"><a tal:attributes="href python:url(['/files', change.revno]);
-                                            title string:browse files at revision ${change/revno}"
-                            tal:content="string:browse files at revision ${change/revno}"></a></li>
+                                            title string:browse files at revision ${change.revno}"
+                            tal:content="string:browse files at revision ${change.revno}"></a></li>
           <li tal:condition="python:remember != change.revno">
             <a tal:attributes="href python:url(['/revision', change.revno], remember=change.revno, compare_revid=None);
                                title string:compare with another revision"
@@ -89,15 +89,15 @@
             <a tal:attributes="href python:url(['/tarball', change.revno])">download tarball</a>
            </li>
           <li id="last"><a tal:attributes="href python:url(['/changes', change.revno]);
-                                           title string:view history from revision ${change/revno}"
-                           tal:content="string:view history from revision ${change/revno}"></a></li>
+                                           title string:view history from revision ${change.revno}"
+                           tal:content="string:view history from revision ${change.revno}"></a></li>
         </ul>
 
         <tal:we-are-comparing condition="python:compare_revid is not None">
           <ul id="submenuTabs">
             <li id="first">
               <a tal:attributes="href python:url([ '/revision', history.get_revno(compare_revid) ], remember=change.revno, compare_revid=change.revno)">
-                reverse the comparison (<tal:b content="change/revno" /> to <tal:b content="python:history.get_revno(compare_revid)" />)
+                reverse the comparison (<tal:b content="change.revno" /> to <tal:b content="python:history.get_revno(compare_revid)" />)
               </a>
             </li>
             <li id="last">
@@ -151,7 +151,7 @@
                   <div class="pseudotable unified"
                        tal:repeat="chunk diff_chunks">
 
-                    <tal:block condition="not:repeat/chunk/start">
+                    <tal:block condition="not:repeat.chunk.start">
                       <div class="pseudorow context-row">
                         <div class="lineNumber separate"></div>
                         <div class="lineNumber second separate"></div>
@@ -160,13 +160,13 @@
                       </div>
                     </tal:block>
 
-                    <div tal:repeat="line chunk/diff"
-                         tal:attributes="class string:pseudorow ${line/type}-row">
+                    <div tal:repeat="line chunk.diff"
+                         tal:attributes="class string:pseudorow ${line.type}-row">
                       <div class="lineNumber first"
                            tal:content="structure python:util.fill_div(line.old_lineno)"></div>
                       <div class="lineNumber second"
                            tal:content="structure python:util.fill_div(line.new_lineno)"></div>
-                      <div tal:attributes="class string:code ${line/type}"
+                      <div tal:attributes="class string:code ${line.type}"
                            tal:content="structure python:util.fill_div(util.html_clean(line.line))"></div>
                       <div class="clear"><!-- --></div>
                     </div>
@@ -179,16 +179,16 @@
 
         <tal:block condition="not:specific_path">
           <div class="diff"
-               tal:repeat="item file_changes/text_changes" tal:attributes="id string:diff-${item/index}">
+               tal:repeat="item file_changes.text_changes" tal:attributes="id string:diff-${item.index}">
 
             <div  class="diffBox">
               <a tal:attributes="href python:url(['/revision', change.revno, item.filename], clear=1);
-                                 id string:${item/filename};
-                                 title string:View changes to ${item/filename} only"
+                                 id string:${item.filename};
+                                 title string:View changes to ${item.filename} only"
                  class="the-link">
                 <img tal:attributes="src python:branch.static_url('/static/images/treeCollapsed.png')"
                      class="expand_diff" />
-                <tal:b content="item/filename" />
+                <tal:b content="item.filename" />
               </a>
             </div>
             <div class="diffinfo"  style="display:none">
@@ -201,9 +201,9 @@
 
         <ul tal:condition="python:navigation.prev_page_revid or navigation.next_page_revid"
             id="pages">
-          <li tal:condition="navigation/prev_page_revid"
+          <li tal:condition="navigation.prev_page_revid"
               class="previous">
-            <a tal:attributes="href navigation/prev_page_url">&laquo; Newer</a>
+            <a tal:attributes="href navigation.prev_page_url">&laquo; Newer</a>
           </li>
           <!-- FIXME: Leaving this to eventually show page numbers. Can't show all of them,
                so some magic has to be done to just show the previous and next N page numbers
@@ -213,9 +213,9 @@
                  <li><a href="#"
                         tal:content="page_number"></a></li>
                </tal:block>-->
-          <li tal:condition="navigation/next_page_revid"
+          <li tal:condition="navigation.next_page_revid"
               class="next">
-            <a tal:attributes="href navigation/next_page_url">Older &raquo;</a>
+            <a tal:attributes="href navigation.next_page_url">Older &raquo;</a>
           </li>
         </ul>
 

=== modified file 'loggerhead/templates/revisionfilechanges.pt'
--- loggerhead/templates/revisionfilechanges.pt	2012-09-21 16:58:01 +0000
+++ loggerhead/templates/revisionfilechanges.pt	2022-08-08 16:33:50 +0000
@@ -1,6 +1,6 @@
 <tal:block>
-  <ul tal:repeat="added file_changes/added">
-    <tal:block condition="repeat/added/start">
+  <ul tal:repeat="added file_changes.added">
+    <tal:block condition="repeat.added.start">
       <li class="desc">files added:</li>
     </tal:block>
     <li class="files" tal:omit-tag="python:added.filename == ''"
@@ -8,47 +8,47 @@
       <tal:revision condition="python:added.kind == 'file'"
                     content="structure python:file_link(added.filename)" />
       <tal:revision condition="python:added.kind != 'file'"
-                    content="added/filename" />
+                    content="added.filename" />
     </li>
   </ul>
 
-  <ul tal:repeat="removed file_changes/removed">
-    <tal:block condition="repeat/removed/start">
+  <ul tal:repeat="removed file_changes.removed">
+    <tal:block condition="repeat.removed.start">
       <li class="desc">files removed:</li>
     </tal:block>
     <li class="files">
       <tal:revision condition="python:removed.kind == 'file'"
                     content="structure python:file_link(removed.filename)" />
       <tal:revision condition="python:removed.kind != 'file'"
-                    content="removed/filename" />
+                    content="removed.filename" />
     </li>
   </ul>
 
-  <ul tal:repeat="renamed file_changes/renamed">
-    <tal:block condition="repeat/renamed/start">
+  <ul tal:repeat="renamed file_changes.renamed">
+    <tal:block condition="repeat.renamed.start">
       <li class="desc">files renamed:</li>
     </tal:block>
     <li class="files">
-      <tal:old-name content="renamed/old_filename" class="filename">
+      <span tal:content="renamed.old_filename" class="filename">
         old_filename
-      </tal:old-name>
+      </span>
       =&gt;
-      <tal:revision condition="renamed/text_modified" content="structure python:file_link(renamed.new_filename)" />
-      <tal:old-name condition="not:renamed/text_modified" content="renamed/new_filename" class="filename">
+      <tal:revision condition="renamed.text_modified" content="structure python:file_link(renamed.new_filename)" />
+      <span tal:condition="not:renamed.text_modified" tal:content="renamed.new_filename" class="filename">
         new_filename
-      </tal:old-name>
-      <tal:prop-change condition="renamed/exe_change" content="string:*" />
+      </span>
+      <tal:prop-change condition="renamed.exe_change" content="string:*" />
     </li>
   </ul>
 
-  <ul tal:repeat="item file_changes/modified">
-    <tal:block condition="repeat/item/start">
+  <ul tal:repeat="item file_changes.modified">
+    <tal:block condition="repeat.item.start">
       <li class="desc">files modified:</li>
     </tal:block>
     <li class="files">
-      <tal:revision condition="item/text_modified" content="structure python:file_link(item.filename)" />
-      <tal:revision condition="not:item/text_modified" content="item/filename" />
-      <tal:prop-change condition="item/exe_change" content="string:*" />
+      <tal:revision condition="item.text_modified" content="structure python:file_link(item.filename)" />
+      <tal:revision condition="not:item.text_modified" content="item.filename" />
+      <tal:prop-change condition="item.exe_change" content="string:*" />
     </li>
   </ul>
 </tal:block>

=== modified file 'loggerhead/templates/revisioninfo.pt'
--- loggerhead/templates/revisioninfo.pt	2012-02-02 07:42:24 +0000
+++ loggerhead/templates/revisioninfo.pt	2022-08-08 16:33:50 +0000
@@ -16,15 +16,15 @@
             <li class="mfrom" tal:condition="python:change.parents[1:]">
                 <strong>mfrom:</strong>
                 <span tal:repeat="parent python:change.parents[1:]">
-                    <a tal:attributes="title string:Merged From ${parent/revno};
+                    <a tal:attributes="title string:Merged From ${parent.revno};
                                        href python:url(['/revision', parent.revno], clear=1)"
                        tal:content="python:revno_with_nick(parent)"></a>
                 </span>
             </li>
-            <li class="mto" tal:condition="change/merge_points">
+            <li class="mto" tal:condition="change.merge_points">
                 <strong>mto:</strong>
-                <span tal:repeat="merge_point change/merge_points">
-                    <a tal:attributes="title string:Merged In ${merge_point/revno};
+                <span tal:repeat="merge_point change.merge_points">
+                    <a tal:attributes="title string:Merged In ${merge_point.revno};
                                        href python:url(['/revision', merge_point.revno], clear=1)"
                        tal:content="python:revno_with_nick(merge_point)"></a>
                 </span>
@@ -37,16 +37,16 @@
             </li>
             <li class="revid">
                 <strong>Revision ID:</strong>
-                <span tal:content="change/revid"></span>
+                <span tal:content="change.revid"></span>
             </li>
         </ul>
-	<div tal:attributes="class string:foreign-${change/foreign_vcs}"
-	     tal:condition="change/foreign_vcs" 
+	<div tal:attributes="class string:foreign-${change.foreign_vcs}"
+	     tal:condition="hasattr(change, 'foreign_vcs')"
 	     tal:repeat="revid_part python:change.foreign_revid.keys()"
 	     tal:content="python:'%s: %s' % (revid_part, change.foreign_revid[revid_part])"/>
-        <div class="tags" tal:condition="change/tags" tal:content="string:Tags: ${change/tags}"></div>
+        <div class="tags" tal:condition="change.tags" tal:content="string:Tags: ${change.tags}"></div>
         <div class="clear"><!-- --></div>
-        <div class="bug" tal:repeat="bug change/bugs">
+        <div class="bug" tal:repeat="bug change.bugs">
             <a tal:attributes="href bug" tal:content="bug"></a>
         </div>
         <div class="information" tal:content="structure python:util.fixed_width(change.comment)"></div>

=== modified file 'loggerhead/templates/revlog.pt'
--- loggerhead/templates/revlog.pt	2009-03-31 15:23:54 +0000
+++ loggerhead/templates/revlog.pt	2022-08-08 16:33:50 +0000
@@ -6,7 +6,7 @@
            tal:content="python:revno_with_nick(parent)"></a>
       </span>
     </li>
-    <li class="mto" tal:repeat="merge_point entry/merge_points">
+    <li class="mto" tal:repeat="merge_point entry.merge_points">
       <a tal:attributes="href python:url(['/changes', merge_point.revno])"
          tal:content="python:revno_with_nick(merge_point)"
          title="Show history" class="link"></a>

=== modified file 'loggerhead/templates/view.pt'
--- loggerhead/templates/view.pt	2022-07-06 12:45:28 +0000
+++ loggerhead/templates/view.pt	2022-08-08 16:33:50 +0000
@@ -1,10 +1,10 @@
 <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
           "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
-<html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros/main">
+<html xmlns="http://www.w3.org/1999/xhtml" metal:use-macro="macros.main">
   <head>
     <title metal:fill-slot="title"
-           tal:content="string:${branch/friendly_name} : contents of ${file_path}
-                        at revision ${change/revno}">
+           tal:content="string:${branch.friendly_name} : contents of ${file_path}
+                        at revision ${change.revno}">
     </title>
     <metal:block fill-slot="header_extras">
         <link rel="stylesheet" type="text/css" media="all"
@@ -16,27 +16,27 @@
 
   <body>
       <tal:block metal:fill-slot="backlink">
-          <tal:has-link condition="branch/branch_link">
+          <tal:has-link condition="branch.branch_link">
             <div class="black-link">
-                <a tal:attributes="href branch/branch_link">
+                <a tal:attributes="href branch.branch_link">
                   &#8592; Back to branch summary
                 </a>
             </div>
           </tal:has-link>
       </tal:block>
-      <tal:block metal:fill-slot="branchname" tal:content="string:${branch/friendly_name}" />
+      <tal:block metal:fill-slot="branchname" tal:content="branch.friendly_name" />
           <tal:block metal:fill-slot="heading">
           <div id="breadcrumbs">
-          <tal:has-link condition="branch/branch_link">
-            <a tal:attributes="href branch/branch_link"
-               tal:content="branch/friendly_name">
+          <tal:has-link condition="branch.branch_link">
+            <a tal:attributes="href branch.branch_link"
+               tal:content="branch.friendly_name">
               nice/branch/name
             </a>
           </tal:has-link>
-          <tal:no-link condition="not: branch/branch_link">
-            <span metal:use-macro="breadcrumbs/directory"></span>
+          <tal:no-link condition="not: branch.branch_link">
+            <span metal:use-macro="breadcrumbs.directory"></span>
           </tal:no-link>
-          <span>: <span metal:use-macro="breadcrumbs/branch" /> (revision <tal:revno content="change/revno"></tal:revno>)</span>
+          <span>: <span metal:use-macro="breadcrumbs.branch" /> (revision <tal:revno content="change.revno"></tal:revno>)</span>
         </div>
       </tal:block>
 
@@ -73,8 +73,8 @@
         <table id="logentries">
           <tal:rep tal:condition="annotated" tal:repeat="line contents">
             <tr>
-              <td tal:condition="python:path('repeat/line/number') in annotated"
-                  tal:define="anno python:annotated.get(path('repeat/line/number'), None)"
+              <td tal:condition="python:repeat.line.number in annotated"
+                  tal:define="anno python:annotated.get(repeat.line.number, None)"
                   tal:attributes="rowspan python:anno.revspan"
                   class="viewRev">
                 <a tal:content="python:'%s' % (anno.change.revno,)"
@@ -85,9 +85,9 @@
 
                 <span tal:content="python:anno.message"></span>
               </td>
-              <td tal:attributes="class python:path('repeat/line/number') in annotated and 'viewLine first' or 'viewLine'">
-                <pre><a tal:attributes="id string:L${repeat/line/number}; href string:#L${repeat/line/number}"
-                   tal:content="repeat/line/number">1</a></pre>
+              <td tal:attributes="class python:repeat.line.number in annotated and 'viewLine first' or 'viewLine'">
+                <pre><a tal:attributes="id string:L${repeat.line.number}; href string:#L${repeat.line.number}"
+                   tal:content="repeat.line.number">1</a></pre>
               </td>
               <td class="viewCont"><pre tal:content="structure line"></pre></td>
             </tr>

=== modified file 'loggerhead/tests/test_controllers.py'
--- loggerhead/tests/test_controllers.py	2022-07-06 12:45:28 +0000
+++ loggerhead/tests/test_controllers.py	2022-08-08 16:33:50 +0000
@@ -32,7 +32,6 @@
 
 from ..apps.branch import BranchWSGIApp
 from ..controllers.annotate_ui import AnnotateUI
-from ..controllers.inventory_ui import InventoryUI
 from .test_simple import (
     BasicTests,
     consume_app,
@@ -50,35 +49,51 @@
         self.addCleanup(tree.branch.lock_read().unlock)
         return tree.branch
 
-    def make_bzrbranch_and_inventory_ui_for_tree_shape(self, shape):
+    def make_bzrbranch_and_inventory_ui_for_tree_shape(self, shape, env):
         branch = self.make_bzrbranch_for_tree_shape(shape)
         branch_app = self.make_branch_app(branch)
-        return branch, InventoryUI(branch_app, branch_app.get_history)
+        return branch, branch_app.lookup_app(env)
 
     def test_get_filelist(self):
+        env = {
+            'SCRIPT_NAME': '',
+            'PATH_INFO': '/files',
+            'wsgi.url_scheme': 'http',
+            'SERVER_NAME': 'localhost',
+            'SERVER_PORT': '80',
+            }
         bzrbranch, inv_ui = self.make_bzrbranch_and_inventory_ui_for_tree_shape(
-            ['filename'])
+            ['filename'], env)
         revtree = bzrbranch.repository.revision_tree(bzrbranch.last_revision())
         self.assertEqual(1, len(inv_ui.get_filelist(revtree, '', 'filename', 'head')))
 
     def test_smoke(self):
+        env = {
+            'SCRIPT_NAME': '',
+            'PATH_INFO': '/files',
+            'wsgi.url_scheme': 'http',
+            'SERVER_NAME': 'localhost',
+            'SERVER_PORT': '80',
+            }
         bzrbranch, inv_ui = self.make_bzrbranch_and_inventory_ui_for_tree_shape(
-            ['filename'])
-        start, content = consume_app(inv_ui,
-            {'SCRIPT_NAME': '/files', 'PATH_INFO': ''})
+            ['filename'], env)
+        start, content = consume_app(inv_ui, env)
         self.assertEqual(('200 OK', [('Content-Type', 'text/html')], None),
                          start)
         self.assertContainsRe(content, b'filename')
 
     def test_no_content_for_HEAD(self):
+        env = {
+            'SCRIPT_NAME': '',
+            'PATH_INFO': '/files',
+            'REQUEST_METHOD': 'HEAD',
+            'wsgi.url_scheme': 'http',
+            'SERVER_NAME': 'localhost',
+            'SERVER_PORT': '80',
+            }
         bzrbranch, inv_ui = self.make_bzrbranch_and_inventory_ui_for_tree_shape(
-            ['filename'])
-        start, content = consume_app(inv_ui,
-            {'SCRIPT_NAME': '/files', 'PATH_INFO': '',
-             'REQUEST_METHOD': 'HEAD',
-             'wsgi.url_scheme': 'http',
-               'SERVER_NAME': 'localhost',
-               'SERVER_PORT': '80'})
+            ['filename'], env)
+        start, content = consume_app(inv_ui, env)
         self.assertEqual(('200 OK', [('Content-Type', 'text/html')], None),
                          start)
         self.assertEqual(b'', content)

=== modified file 'loggerhead/zptsupport.py'
--- loggerhead/zptsupport.py	2020-05-06 19:18:04 +0000
+++ loggerhead/zptsupport.py	2022-08-08 16:33:50 +0000
@@ -13,15 +13,13 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Suite 500, Boston, MA 02110-1335  USA
 #
-"""Support for Zope Page Templates using the simpletal library."""
+"""Support for Zope Page Templates using the Chameleon library."""
 
-import logging
 import os
 import pkg_resources
 import re
-from io import StringIO
 
-from simpletal import simpleTAL, simpleTALES
+from chameleon import PageTemplate
 
 _zpt_cache = {}
 
@@ -35,7 +33,7 @@
         text = re.sub(r'\s*\n\s*', '\n', text)
         text = re.sub(r'[ \t]+', ' ', text)
         tinstance = _zpt_cache[tfile] = TemplateWrapper(
-            simpleTAL.compileXMLTemplate(text), tfile, stat)
+            PageTemplate(text), tfile, stat)
     return tinstance
 
 
@@ -47,18 +45,10 @@
         self.stat = stat
 
     def expand(self, **info):
-        context = simpleTALES.Context(allowPythonPath=1)
-        for k, v in info.items():
-            context.addGlobal(k, v)
-        s = StringIO()
-        self.template.expandInline(context, s)
-        return s.getvalue()
+        return self.template(**info)
 
     def expand_into(self, f, **info):
-        context = simpleTALES.Context(allowPythonPath=1)
-        for k, v in info.items():
-            context.addGlobal(k, v)
-        self.template.expand(context, f, outputEncoding='utf-8')
+        f.write(self.template(**info).encode('UTF-8'))
 
     @property
     def macros(self):

=== modified file 'requirements.txt'
--- requirements.txt	2022-07-11 13:08:09 +0000
+++ requirements.txt	2022-08-08 16:33:50 +0000
@@ -8,7 +8,6 @@
 bleach; python_version > "3.5"
 bleach < 4.0.0; python_version <= "3.5"
 packaging < 21.0; python_version <= "3.5"
-https://www.owlfish.com/software/simpleTAL/downloads/SimpleTAL-5.2.tar.gz
 Pygments < 2.12; python_version <= "3.5"
 Pygments; python_version > "3.5"
 certifi < 2022.5.18; python_version <= "3.5"

